#include <QtGui>

extern "C"
{
	#include <libavformat/avformat.h>
	#include <libavcodec/avcodec.h>
	#include <libswscale/swscale.h>
}

const QString settingsFile = QDir::homePath() + "/.z166_kde4_ffmpeg_thumbnails.conf";

struct FFmpeg
{
	FFmpeg( QImage &, int, int );
	~FFmpeg();

	AVFormatContext *formatCtx;
	AVCodecContext *codecCtx;
	SwsContext *img_convert_ctx;
	AVPicture frameRGB;
	AVFrame pFrame;
	int videoStream, W, H, w, h;
	uchar *buffer;
	QImage *image;
	bool chkKeyFrame;

	bool decodeFrame( bool );
	bool seekToFrame( uint64_t );
	void read( QString );
};

#include <kio/thumbcreator.h>

struct z166_kde4_ffmpeg_thumbnails : public ThumbCreator
{
	public:
		z166_kde4_ffmpeg_thumbnails();
		bool create( const QString &, int, int, QImage & );
};
